﻿<?php

require_once('./lastRSS.php');

define("VC_PDB_API_URL", "http://webservice.valuecommerce.ne.jp/productdb/search");

$v_category = VC_PDB_CATEGORY;

$v_sort_type = VC_PDB_SORT_ORDER;

//
//
//
//

// URLエンコード
$search_keyword = urlencode(str_replace(" ", "+", trim(VC_PDB_KEYWORD))); 

$v_page = "";
$v_sort_by = "";
$v_sort_order = "";
$v_page = 1;
$v_sort_by = "";
$v_sort_order = "";

$rss = new lastRSS;
$rss->cache_dir = './cache';
$rss->cache_time = 7200; //2時間

switch ($v_sort_type) {
case 0: //スコア順
	$v_sort_by = "score";
	$v_sort_order = "asc";
	break;
case 1: //価格安い順
	$v_sort_by = "price";
	$v_sort_order = "desc";
	break;
case 2: //価格高い順
	$v_sort_by = "price";
	$v_sort_order = "asc";
	break;
default:
	break;
}

$url = VC_PDB_API_URL . "?token=" . VC_PDB_API_TOKEN . "&keyword=$search_keyword&category=$v_category&sort_by=$v_sort_by&sort_order=$v_sort_order&page=$v_page&results_per_page=" . VC_PDB_VIEW_CNT;
$rs = $rss->Get($url); //APIを使う

//検索結果の描画部分
foreach ($rs['items'] as $item) {
	//商品情報（商品名にMyLink形式）
	echo "<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">";
	echo "<tr valign=\"top\">";
	echo " <td width=\"100\" valign=\"top\">" . GetBannerTag($item["link"], GetImageTag($item)) . "</td>";
	echo " <td>" . GetBannerTag($item["link"], $item["title"]) . " &yen;" . number_format($item['vc:price']) . "<br>";
	echo GetDescription($item, DESC_MAX_LEN);
	echo " </td>";
	echo "</tr>";
	echo "</table>\n";
}

//バナーの生成（ckからadタグを含めたタグを作る）
//入力値:クリック先のリンク、自由テキスト
//戻り値:バナーのタグ文字列
function GetBannerTag($ckurl, $txt) {
	//$ckのurl
	$ckurl = str_replace('&amp;', '&', $ckurl);

	//adのurl
	$pattern = '/(http:\/\/)ck(.*)referral\?(.*)(&vc_url=.*)/';
	$replacement = '${1}ad${2}gifbanner?${3}';
	$adurl = preg_replace($pattern, $replacement, $ckurl);

	$url = '<a href="' . $ckurl . '" target="_blank">'; //ckタグ
	$url .= $txt;
	$url .= '<img Src="' . $adurl . '" height="1" width="1" Border="0">'; //adタグ
	$url .= '</a>';

	return $url;
}

//イメージタグの取得
//入力値:アイテム要素のハッシュ
//戻り値:イメージタグ文字列（イメージが取得できない場合は「画像なし」の画像）
function GetImageTag($item) {
	//サイズの決定（Large -> Free -> Smallの順で）
	if(isset($item["vc:imageLarge"])) {
		$src = $item["vc:imageLarge"];
		if (isset($item["vc:imageLargeH"])) {
			$h = $item["vc:imageLargeH"];
		}
		if (isset($item["vc:imageLargeW"])) {
			$w = $item["vc:imageLargeW"];
		}
		if ($w > 100) { //幅は最大100として、縦横比を合わせる
			$h = 100 * $h / $w;
			$w = 100;
		}
	} else if (isset($item["vc:imageFree"])){
		$src = $item["vc:imageFree"];
		if (isset($item["vc:imageFreeH"])) {
			$h = $item["vc:imageFreeH"];
		}
		if (isset($item["vc:imageFreeW"])) {
			$w = $item["vc:imageFreeW"];
		}
		if ($w > 100) {
			$h = 100 * $h / $w;
			$w = 100;
		}
	} else if (isset($item["vc:imageSmall"])){
		$src = $item["vc:imageSmall"];
		if (isset($item["vc:imageSmallH"])) {
			$h = $item["vc:imageSmallH"];
		}
		if (isset($item["vc:imageSmallW"])) {
			$w = $item["vc:imageSmallW"];
		}
		if ($w > 100) {
			$h = 100 * $h / $w;
			$w = 100;
		}
	}
	//イメージタグの決定
	if(isset($src)) {
		$s = '<img src="' . $src . '"';
		if(isset($h)) {
			$s .= ' height="' . $h . '"';
		}
		if(isset($w)) {
			$s .= ' width="' . $w . '"';
		}
		$s .= '>';
	} else {
		$s = '<img src="noimage100.gif" height="100" width="100">'; //イメージがないの場合
	}
	return $s;
}

//商品詳細
//入力値:アイテム要素のハッシュ
//戻り値:商品詳細（文字列）
function GetDescription($item, $maxlen) {
	if (isset($item['description'])) {
		$s = mb_substr($item['description'], 0, $maxlen, "UTF-8");
		if (mb_strlen($item['description']) > $maxlen) {
			$s .= '...'; //maxlen以上の場合は、「...」を付与
		}
	} else {
		$s = '商品詳細はありません。';
	}
	return $s;
}

?>